# FoxDebug.py
# 2009 Fredrik 'Grey Fox' Henriksson

from CvPythonExtensions import *
import CvScreensInterface
from colors import *
from TabElements import *
from collections import deque
import CvUtil
import string
import random
import time
import pickle

import FoxStorage

localText = CyTranslator()


class DynamicTraitsTab(FoxStorage.FoxStorage):
	"""
	Overides FoxStorage
	"""
	

# Grey Fox Debug
class FoxDebug:
	def __init__(self, title="Grey Fox Debug Window", width = 600, height = 440):
		self.szWindowTitle		= title
		self.width 				= width
		self.height 			= height
		self.iScreenHeight		= 50
		self.Tab				= {}
		self.bCreated 			= False
		self.callbackIFace 		= "CvOptionsScreenCallbackInterface"
		
#################### GREY FOX DEBUG TEXT ######################
	def saveData(self):
		
		aData = []
		
		aData.append(self.Tab)
		#aData.append(self.History)
		#aData.append(self.TextThisTurn)
		#aData.append(self.ffTimes)
		#aData.append(self.gfTimes)
		
		return aData
		
	def loadData(self, aData):
		
		iIterator = 0
		
		self.Tab = aData[iIterator]
		iIterator += 1
		#self.History = aData[iIterator]
		#iIterator += 1
		#self.TextThisTurn = aData[iIterator]
		#iIterator += 1
		#self.ffTimes = aData[iIterator]
		#iIterator += 1
		#self.gfTimes = aData[iIterator]
		#iIterator += 1
		
	def getTabControl(self):
		return self.pTabControl

	def drawSetupTab(self):
		"""
		Tab for setting the debug up
		"""
		pWindow = self.pTabControl
		title = "Setup"
		
		panel = title+"Form"
		pWindow.attachTabItem(panel, title)
		
		parent = panel
		panel = title+"VBoxParent"
		pWindow.attachVBox(parent, panel)
		
		parent = panel
		panel = title+"PanelCenter"
		pWindow.attachPanel(parent, panel)
		pWindow.setStyle(panel, "Panel_Empty")
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_HEXPANDING")
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_VEXPANDING")
		
		parent = panel
		panel = title+"Panel"
		pWindow.attachScrollPanel(parent, panel)
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_HEXPANDING")
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_VEXPANDING")

		parent = panel
		panel = title+"TextBox"
		pWindow.attachVBox(parent, panel)
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_HMIN")
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_HMIN")
	
	def isTab(self, szName):
		return self.Tab.has_key(szName)
		
	def addNewTab(self, szName):
		self.Tab[szName] = DynamicTraitsTab(szName)
	
	def redrawWindow(self, iPlayer = 1):
		"""
		Called when the window is to be created
		"""
		screen = CyGInterfaceScreen( "MainInterface", 99 )
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()
		
		szWinTitle = self.szWindowTitle
		
		self.pTabControl = CyGTabCtrl(szWinTitle, True, True)
		pWindow = self.pTabControl
		
		pWindow.setModal(0)
		pWindow.setSize(self.width, self.height)
		pWindow.setControlsExpanding(False)
		pWindow.setColumnLength(self.iScreenHeight)
		pWindow.setNumColumns(200)
		
		self.bCreated = True
		self.updateWindow(iPlayer)

	def updateWindow(self, iPlayer):
		"""
		Called everytime the window is to be redrawn
		"""
		
		for title, object in self.Tab.iteritems():
			self.updateTab(title, iPlayer)
		
		self.drawSetupTab()
	
	def updateTab(self, title, iPlayer):
		"""
		Tab where Messages are shown
		"""		
		pWindow = self.pTabControl
		pTab = self.Tab[title]
		
		title = pTab.getTitle()
		
		panel = title+"Form"
		pWindow.attachTabItem(panel, title)
		
		parent = panel
		panel = title+"VBoxParent"
		pWindow.attachVBox(parent, panel)
		
		parent = panel
		panel = title+"PanelCenter"
		pWindow.attachPanel(parent, panel)
		pWindow.setStyle(panel, "Panel_Empty")
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_HEXPANDING")
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_VEXPANDING")
		
		parent = panel
		panel = title+"Panel"
		pWindow.attachScrollPanel(parent, panel)
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_HEXPANDING")
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_VEXPANDING")

		parent = panel
		panel = title+"TextBox"
		pWindow.attachVBox(parent, panel)
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_HMIN")
		pWindow.setLayoutFlag(panel, "LAYOUT_SIZE_HMIN")
		
		self.populateRows(title, iPlayer)
		
	def populateRows(self, title, iPlayer):
		"""
		Prints out the rows of text on the window tab
		"""
		
		pTab = self.Tab[title]
		
		Text = pTab.getCurrent(iPlayer)
		size = len(Text)
		if size > 255:
			pTab.updateLibrary(iPlayer)
			size = 255
		if size > 0:
			queue = deque(reversed(Text))
			while size > 0:
				self.addRow(title, iPlayer, queue.popleft())
				size-=1
		#pTab.clearText()
	
	def addRow(self, title, iPlayer, szText):
		"""
		Add rows, which is basically one or several labels, with a separator after
		"""
		pWindow = self.pTabControl
		pTab = self.Tab[title]
		title = pTab.getTitle()
		iRow = pTab.getRows(iPlayer)
		
		prefix = "%s%s" % (title, "Row")
		szBox = "%s%s" % (title, "TextBox")
		szName = szBox
		
		bList = szText.split()
		cNewString = ""; i = 0
		Lines = deque([])
		for word in bList:
			find = word.find("[NEWLINE]")
			if find != -1:
				if word[:9] == '[NEWLINE]':
					split = word.split('[NEWLINE]')
					Lines.append(cNewString)
					cNewString = "%s " % (split[1])
				else:
					split = word.split('[NEWLINE]')
					
					cNewString = "%s %s" % (cNewString, split[0])
					Lines.append(cNewString)
					cNewString = "%s " % (split[0])

				continue
				
			if len(cNewString) >= 56:
				Lines.append(cNewString)
				cNewString = ""
		 
			cNewString = "%s%s " % (cNewString, word)
		
		sep = "%s%d%s" % (szName, iRow, "Sep")
		for line in Lines:
			szName = "%s%d" % (prefix, iRow)
			addLabel( pWindow, szBox, szName, line);
			pWindow.attachHSeparator(szBox, sep)
			iRow += 1
		
		# Keep count of rows
		pTab.addRows(iPlayer, iRow)
	
	def addLine(self, szTitle, iPlayer, szMsg):
		if not self.isTab(szTitle):
			self.addNewTab(szTitle)
		
		pTab			= self.Tab[szTitle]
		addLine			= pTab.addLine
		addLine(iPlayer, szMsg)
		
	
	def updateTraitCounterTab(self, iPlayer, iTurn):
		gc 				= CyGlobalContext() 
		getPlayer 		= gc.getPlayer
		pPlayer 		= getPlayer(iPlayer)
		getCounter 		= pPlayer.getTraitCounter
		changeCounter 	= pPlayer.changeTraitCounter
		traitInfo 		= gc.getTraitInfo
		
		
		if not self.isTab("Trait Counters"):
			self.addNewTab("Trait Counters")
		
		pTab			= self.Tab["Trait Counters"]
		addLine			= pTab.addLine
	
		#pTab.updateLibrary()
		n = "[NEWLINE]"
		szTurn = "(Turn: %d)" % (iTurn)
		for eTrait in range(gc.getNumTraitInfos()):
			iCounter = getCounter(eTrait)
			if iCounter != 0:
				szMsg = "%s: %s: %d %s" % (szTurn, traitInfo(eTrait).getDescription(), iCounter, n)
				addLine(iPlayer, szMsg)
		szName = gc.getCivilizationInfo(pPlayer.getCivilizationType()).getDescription()
		szMsg = "========== %s ==========%s" % (szName, n)
		addLine(iPlayer, szMsg)
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
	
		
	