# FoxTools.py
# 2009 Fredrik 'Grey Fox' Henriksson

#szText = "lorem ipsum dolor sit amet consectetur adipiscing elit integer et blandit"
#for i in range(10):
#	aString += self.jumble(szText)
"""
def jumble(text):
	list = text.split()
	random.shuffle(list)
	szText = ""
	for word in list:
		szText += word +"] "
	return szText
"""

from CvPythonExtensions import *
import CvUtil
import Popup as PyPopup
import PyHelpers
import CvEventInterface
import CvScreenEnums

# GLOBALS
localText = CyTranslator()
PyPlayer = PyHelpers.PyPlayer
# RANGES
ROUND_RANGE = [(0,-1),(0,1),(-1,0),(1,0),(1,-1),(1,1),(-1,1),(-1,-1)]
RANGE1 = [(0,-1),(0,1),(-1,0),(1,0)]
RANGE2 = [(0,-2),(0,2),(-2,0),(2,0),(1,-1),(-1,1),(-1,-1),(1,1)]

# Grey Fox Tools
class FoxTools:

	def __init__(self):
		self.Traits 		= {}
		self.initTraitDict()
		self.Civics 		= {}
		self.initCivicDict()
		self.Buildings 		= {}
		self.initBuildingDict()
		self.UnitCombats 	= {}
		self.initUnitCombatDict()
		self.Improvements 	= {}
		self.initImprovementDict()
		self.GreatPeople 	= {}
		self.initGreatPeopleDict()
		self.popupMsg 		= {}
	
	def getPopupMsg(self, index):
		List = []
		if self.popupMsg.has_key(index):
			List = self.popupMsg[index]
		return List
	
	def addPopupMsg(self, index, szText, szArt ):
		List = []
		if self.popupMsg.has_key(index):
			List = self.popupMsg[index]
		List.append( [ szText, szArt ] )
		self.popupMsg[index] = List
	
	def showTraitPopup(self):
		
		Lost 	= self.getPopupMsg("Lost")
		Gained 	= self.getPopupMsg("Gained")
		iLen 	= 0
		iLen 	+= len(Lost)
		iLen 	+= len(Gained)
		
		if iLen == 0: return
		
		szTitle = CyGameTextMgr().getTimeStr(CyGame().getGameTurn(), false)
		popup = PyPopup.PyPopup(-1)
		
		popup.setHeaderString(szTitle)
		
		iCount = 0
		if len(Gained) > 0:
			szArt = 'art/interface/popups/TraitsGained.dds'
			popup.addDDS(szArt, 0, 0, 48, 344)
			for msg, art in Gained:
				# popup.addSeparator()
				popup.setBodyString(msg)
				iCount += 1
			popup.addSeparator()
		
		iCount = 0
		if len(Lost) > 0:
			szArt = 'art/interface/popups/TraitsLost.dds'
			popup.addDDS(szArt, 0, 0, 48, 344)
			for msg, art in Lost:
				# popup.addSeparator()
				popup.setBodyString(msg)
				iCount += 1
		
		self.popupMsg = {}
		popup.launch(true, PopupStates.POPUPSTATE_IMMEDIATE)
	
	def getTraitDict(self):
		return self.Traits
		
	def initTraitDict(self):
		gc = CyGlobalContext()
		getInfoType = gc.getInfoTypeForString
		Dict = {}
		Dict["Aggressive"] 		= getInfoType('TRAIT_AGGRESSIVE')
		Dict["Agrarianist"]		= getInfoType('TRAIT_AGRARIANIST')
		Dict["Agricultural"]	= getInfoType('TRAIT_AGRICULTURAL')
		Dict["Analytical"] 		= getInfoType('TRAIT_ANALYTICAL')
		Dict["Authoritarian"] 	= getInfoType('TRAIT_AUTHORITARIAN')
		Dict["Backstabber"] 	= getInfoType('TRAIT_BACKSTABBER')
		Dict["Benevolent"] 		= getInfoType('TRAIT_BENEVOLENT')
		Dict["Capitalist"] 		= getInfoType('TRAIT_CAPITALIST')
		Dict["Charismatic"] 	= getInfoType('TRAIT_CHARISMATIC')
		Dict["Commercial"] 		= getInfoType('TRAIT_COMMERCIAL')
		Dict["Creative"] 		= getInfoType('TRAIT_CREATIVE')
		Dict["Cruel"] 			= getInfoType('TRAIT_CRUEL')
		Dict["Democratic"] 		= getInfoType('TRAIT_DEMOCRATIC')
		Dict["Diplomatic"] 		= getInfoType('TRAIT_DIPLOMATIC')
		Dict["Expansive"] 		= getInfoType('TRAIT_EXPANSIVE')
		Dict["Explorers"] 		= getInfoType('TRAIT_EXPLORERS')
		Dict["Feudalist"] 		= getInfoType('TRAIT_FEUDALIST')
		Dict["Financial"] 		= getInfoType('TRAIT_FINANCIAL')
		Dict["Fishermen"] 		= getInfoType('TRAIT_FISHERMEN')
		Dict["Horselords"] 		= getInfoType('TRAIT_HORSELORDS')
		Dict["Humanitarian"] 	= getInfoType('TRAIT_HUMANITARIAN')
		Dict["Industrious"] 	= getInfoType('TRAIT_INDUSTRIOUS')
		Dict["Imperialist"] 	= getInfoType('TRAIT_IMPERIALIST')
		Dict["Isolationist"] 	= getInfoType('TRAIT_ISOLATIONIST')
		Dict["Libertarian"] 	= getInfoType('TRAIT_LIBERTARIAN')
		Dict["Nationalist"]		= getInfoType('TRAIT_NATIONALIST')
		Dict["Nonviolent"] 		= getInfoType('TRAIT_NONVIOLENT')
		Dict["Organized"] 		= getInfoType('TRAIT_ORGANIZED')
		Dict["Pastoralist"] 	= getInfoType('TRAIT_PASTORALIST')
		Dict["Peaceful"] 		= getInfoType('TRAIT_PEACEFUL')
		Dict["Philosophical"]   = getInfoType('TRAIT_PHILOSOPHICAL')
		Dict["Peaceful"] 		= getInfoType('TRAIT_PEACEFUL')
		Dict["Productive"] 		= getInfoType('TRAIT_PRODUCTIVE')
		Dict["Protective"] 		= getInfoType('TRAIT_PROTECTIVE')
		Dict["Raiders"] 		= getInfoType('TRAIT_RAIDERS')
		Dict["Scientific"] 		= getInfoType('TRAIT_SCIENTIFIC')
		Dict["Seafaring"] 		= getInfoType('TRAIT_SEAFARING')
		Dict["Socialist"] 		= getInfoType('TRAIT_SOCIALIST')
		Dict["Spiritual"]	 	= getInfoType('TRAIT_SPIRITUAL')
		Dict["Theocrat"]	 	= getInfoType('TRAIT_THEOCRAT')
		Dict["Traders"]	 		= getInfoType('TRAIT_TRADERS')
		self.Traits = Dict
		
	def getCivicDict(self):
		return self.Civics
	
	def initCivicDict(self):
		gc = CyGlobalContext()
		getInfoType = gc.getInfoTypeForString
		Dict = {}
		Dict["Government"] 			= getInfoType('CIVICOPTION_GOVERNMENT')
		Dict["Despotism"] 			= getInfoType('CIVIC_DESPOTISM')
		Dict["Hereditary Rule"] 	= getInfoType('CIVIC_HEREDITARY_RULE')
		Dict["Representation"]		= getInfoType('CIVIC_REPRESENTATION')
		Dict["Police State"] 		= getInfoType('CIVIC_POLICE_STATE')
		Dict["Universal Suffrage"] 	= getInfoType('CIVIC_UNIVERSAL_SUFFRAGE')
		
		Dict["Legal"] 			= getInfoType('CIVICOPTION_LEGAL')
		Dict["Barbarism"] 		= getInfoType('CIVIC_BARBARISM')
		Dict["Vassalage"] 		= getInfoType('CIVIC_VASSALAGE')
		Dict["Bureaucracy"] 	= getInfoType('CIVIC_BUREAUCRACY')
		Dict["Nationhood"] 		= getInfoType('CIVIC_NATIONHOOD')
		Dict["Free Speech"]		= getInfoType('CIVIC_FREE_SPEECH')
		
		Dict["Labor"] 			= getInfoType('CIVICOPTION_LABOR')
		Dict["Barbarism"] 		= getInfoType('CIVIC_TRIBALISM')
		Dict["Slavery"] 		= getInfoType('CIVIC_SLAVERY')
		Dict["Serfdom"] 		= getInfoType('CIVIC_SERFDOM')
		Dict["Caste System"]	= getInfoType('CIVIC_CASTE_SYSTEM')
		Dict["Emancipation"]	= getInfoType('CIVIC_EMANCIPATION')
		
		Dict["Economy"] 			= getInfoType('CIVICOPTION_ECONOMY')
		Dict["Decentralization"] 	= getInfoType('CIVIC_DECENTRALIZATION')
		Dict["Mercentalism"] 		= getInfoType('CIVIC_MERCANTILISM')
		Dict["Free Market"] 		= getInfoType('CIVIC_FREE_MARKET')
		Dict["State Property"] 		= getInfoType('CIVIC_STATE_PROPERTY')
		Dict["Environmentalism"] 	= getInfoType('CIVIC_ENVIRONMENTALISM')
		
		Dict["Religion"] 			= getInfoType('CIVICOPTION_RELIGION')
		Dict["Paganism"]	 		= getInfoType('CIVIC_PAGANISM')
		Dict["Organized Religion"]  = getInfoType('CIVIC_ORGANIZED_RELIGION')
		Dict["Theocracy"] 			= getInfoType('CIVIC_THEOCRACY')
		Dict["Pacifism"] 			= getInfoType('CIVIC_PACIFISM')
		Dict["Free Religion"] 		= getInfoType('CIVIC_FREE_RELIGION')
		self.Civics = Dict
			
	def getBuildingDict(self):
		return self.Buildings
		
	def initBuildingDict(self):
		gc = CyGlobalContext()
		getInfoType = gc.getInfoTypeForString
		Dict = {}
		Dict["Palace"] 				= getInfoType('BUILDINGCLASS_PALACE')
		Dict["Versailles"] 			= getInfoType('BUILDINGCLASS_VERSAILLES')
		Dict["Walls"] 				= getInfoType('BUILDINGCLASS_WALLS')
		Dict["Castle"] 				= getInfoType('BUILDINGCLASS_CASTLE')
		Dict["Barracks"] 			= getInfoType('BUILDINGCLASS_BARRACKS')
		Dict["Stable"] 				= getInfoType('BUILDINGCLASS_STABLE')
		Dict["Bunker"] 				= getInfoType('BUILDINGCLASS_BUNKER')
		Dict["Bomb Shelter"] 		= getInfoType('BUILDINGCLASS_BOMB_SHELTER')
		Dict["Granary"] 			= getInfoType('BUILDINGCLASS_GRANARY')
		Dict["Aqueduct"] 			= getInfoType('BUILDINGCLASS_AQUEDUCT')
		Dict["Hospital"] 			= getInfoType('BUILDINGCLASS_HOSPITAL')
		Dict["Recycling Center"] 	= getInfoType('BUILDINGCLASS_RECYCLING_CENTER')
		Dict["Lighthouse"] 			= getInfoType('BUILDINGCLASS_LIGHTHOUSE')
		Dict["Harbor"] 				= getInfoType('BUILDINGCLASS_HARBOR')
		Dict["Custom House"] 		= getInfoType('BUILDINGCLASS_CUSTOM_HOUSE')
		Dict["Drydock"] 			= getInfoType('BUILDINGCLASS_DRYDOCK')
		Dict["Airport"] 			= getInfoType('BUILDINGCLASS_AIRPORT')
		Dict["Forge"] 				= getInfoType('BUILDINGCLASS_FORGE')
		Dict["Factory"] 			= getInfoType('BUILDINGCLASS_FACTORY')
		Dict["Coal Plant"] 			= getInfoType('BUILDINGCLASS_COAL_PLANT')
		Dict["Hydro Plant"] 		= getInfoType('BUILDINGCLASS_HYDRO_PLANT')
		Dict["Nuclear Plant"] 		= getInfoType('BUILDINGCLASS_NUCLEAR_PLANT')
		Dict["Industrial Park"] 	= getInfoType('BUILDINGCLASS_INDUSTRIAL_PARK')
		Dict["Obelisk"] 			= getInfoType('BUILDINGCLASS_OBELISK')
		Dict["Public Transportation"] 	= getInfoType('BUILDINGCLASS_PUBLIC_TRANSPORTATION')
		Dict["Academy"] 			= getInfoType('BUILDINGCLASS_ACADEMY')
		Dict["Library"] 			= getInfoType('BUILDINGCLASS_LIBRARY')
		Dict["Observatory"] 		= getInfoType('BUILDINGCLASS_OBSERVATORY')
		Dict["Laboratory"] 			= getInfoType('BUILDINGCLASS_LABORATORY')
		Dict["Theathre"] 			= getInfoType('BUILDINGCLASS_THEATRE')
		Dict["Colosseum"] 			= getInfoType('BUILDINGCLASS_COLOSSEUM')
		Dict["Broadcast Tower"] 	= getInfoType('BUILDINGCLASS_BROADCAST_TOWER')
		Dict["Market"] 				= getInfoType('BUILDINGCLASS_MARKET')
		Dict["Grocer"] 				= getInfoType('BUILDINGCLASS_GROCER')
		Dict["Bank"] 				= getInfoType('BUILDINGCLASS_BANK')
		Dict["Supermarket"] 		= getInfoType('BUILDINGCLASS_SUPERMARKET')
		Dict["Courthouse"] 			= getInfoType('BUILDINGCLASS_COURTHOUSE')
		Dict["Jail"] 				= getInfoType('BUILDINGCLASS_JAIL')
		Dict["Levee"] 				= getInfoType('BUILDINGCLASS_LEVEE')
		Dict["Intelligence Agency"] = getInfoType('BUILDINGCLASS_INTELLIGENCE_AGENCY')
		Dict["National Security"] 	= getInfoType('BUILDINGCLASS_NATIONAL_SECURITY')
		Dict["Jewish Temple"] 		= getInfoType('BUILDINGCLASS_JEWISH_TEMPLE')
		Dict["Jewish Cathedral"]	= getInfoType('BUILDINGCLASS_JEWISH_CATHEDRAL')
		Dict["Jewish Monastery"]	= getInfoType('BUILDINGCLASS_JEWISH_MONASTERY')
		Dict["Jewish Shrine"] 		= getInfoType('BUILDINGCLASS_JEWISH_SHRINE')
		Dict["Christian Temple"] 	= getInfoType('BUILDINGCLASS_CHRISTIAN_TEMPLE')
		Dict["Christian Cathedral"]	= getInfoType('BUILDINGCLASS_CHRISTIAN_CATHEDRAL')
		Dict["Christian Monastery"]	= getInfoType('BUILDINGCLASS_CHRISTIAN_MONASTERY')
		Dict["Christian Shrine"] 	= getInfoType('BUILDINGCLASS_CHRISTIAN_SHRINE')
		Dict["Islamic Temple"] 		= getInfoType('BUILDINGCLASS_ISLAMIC_TEMPLE')
		Dict["Islamic Cathedral"]	= getInfoType('BUILDINGCLASS_ISLAMIC_CATHEDRAL')
		Dict["Islamic Monastery"]	= getInfoType('BUILDINGCLASS_ISLAMIC_MONASTERY')
		Dict["Islamic Shrine"] 		= getInfoType('BUILDINGCLASS_ISLAMIC_SHRINE')
		Dict["Hindu Temple"] 		= getInfoType('BUILDINGCLASS_HINDU_TEMPLE')
		Dict["Hindu Cathedral"] 	= getInfoType('BUILDINGCLASS_HINDU_CATHEDRAL')
		Dict["Hindu Monastery"] 	= getInfoType('BUILDINGCLASS_HINDU_MONASTERY')
		Dict["Hindu Shrine"] 		= getInfoType('BUILDINGCLASS_HINDU_SHRINE')
		Dict["Buddhist Temple"] 	= getInfoType('BUILDINGCLASS_BUDDHIST_TEMPLE')
		Dict["Buddhist Cathedral"] 	= getInfoType('BUILDINGCLASS_BUDDHIST_CATHEDRAL')
		Dict["Buddhist Monastery"] 	= getInfoType('BUILDINGCLASS_BUDDHIST_MONASTERY')
		Dict["Buddhist Shrine"] 	= getInfoType('BUILDINGCLASS_BUDDHIST_SHRINE')
		Dict["Confucian Temple"] 	= getInfoType('BUILDINGCLASS_CONFUCIAN_TEMPLE')
		Dict["Confucian Cathedral"] = getInfoType('BUILDINGCLASS_CONFUCIAN_CATHEDRAL')
		Dict["Confucian Monastery"] = getInfoType('BUILDINGCLASS_CONFUCIAN_MONASTERY')
		Dict["Confucian Shrine"] 	= getInfoType('BUILDINGCLASS_CONFUCIAN_SHRINE')
		Dict["Taoist Temple"] 		= getInfoType('BUILDINGCLASS_TAOIST_TEMPLE')
		Dict["Taoist Cathedral"] 	= getInfoType('BUILDINGCLASS_TAOIST_CATHEDRAL')
		Dict["Taoist Monastery"] 	= getInfoType('BUILDINGCLASS_TAOIST_MONASTERY')
		Dict["Taoist Shrine"] 		= getInfoType('BUILDINGCLASS_TAOIST_SHRINE')
		Dict["Heroic Epic"] 		= getInfoType('BUILDINGCLASS_HEROIC_EPIC')
		Dict["National Epic"] 		= getInfoType('BUILDINGCLASS_NATIONAL_EPIC')
		Dict["Globe Theatre"] 		= getInfoType('BUILDINGCLASS_GLOBE_THEATRE')
		Dict["National Park"] 		= getInfoType('BUILDINGCLASS_NATIONAL_PARK')
		Dict["Hermitage"] 			= getInfoType('BUILDINGCLASS_HERMITAGE')
		Dict["Oxford University"] 	= getInfoType('BUILDINGCLASS_OXFORD_UNIVERSITY')
		Dict["Wall Street"] 		= getInfoType('BUILDINGCLASS_WALL_STREET')
		Dict["Iron Works"] 			= getInfoType('BUILDINGCLASS_IRON_WORKS')
		Dict["West Point"] 			= getInfoType('BUILDINGCLASS_WEST_POINT')
		Dict["Mt.Rushmore"] 		= getInfoType('BUILDINGCLASS_MT_RUSHMORE')
		Dict["Red Cross"] 			= getInfoType('BUILDINGCLASS_RED_CROSS')
		Dict["Scotland Yard"] 		= getInfoType('BUILDINGCLASS_SCOTLAND_YARD')
		Dict["Pyramid"] 			= getInfoType('BUILDINGCLASS_PYRAMID')
		Dict["Stonehenge"] 			= getInfoType('BUILDINGCLASS_STONEHENGE')
		Dict["Great Library"] 		= getInfoType('BUILDINGCLASS_GREAT_LIBRARY')
		Dict["Great Lighthouse"] 	= getInfoType('BUILDINGCLASS_GREAT_LIGHTHOUSE')
		Dict["Hanging Garden"] 		= getInfoType('BUILDINGCLASS_HANGING_GARDEN')
		Dict["Colossus"] 			= getInfoType('BUILDINGCLASS_COLOSSUS')
		Dict["Oracle"] 				= getInfoType('BUILDINGCLASS_ORACLE')
		Dict["Parthenon"] 			= getInfoType('BUILDINGCLASS_PARTHENON')
		Dict["Angkor Wat"] 			= getInfoType('BUILDINGCLASS_ANGKOR_WAT')
		Dict["Hagia Sophia"] 		= getInfoType('BUILDINGCLASS_HAGIA_SOPHIA')
		Dict["Chicken Itza"] 		= getInfoType('BUILDINGCLASS_CHICHEN_ITZA')
		Dict["Sistine Chapel"] 		= getInfoType('BUILDINGCLASS_SISTINE_CHAPEL')
		Dict["Notre Dame"] 			= getInfoType('BUILDINGCLASS_NOTRE_DAME')
		Dict["Spiral Minaret"] 		= getInfoType('BUILDINGCLASS_SPIRAL_MINARET')
		Dict["Taj Mahal"] 			= getInfoType('BUILDINGCLASS_TAJ_MAHAL')
		Dict["Kremlin"] 			= getInfoType('BUILDINGCLASS_KREMLIN')
		Dict["Eiffel Tower"] 		= getInfoType('BUILDINGCLASS_EIFFEL_TOWER')
		Dict["Statue of Liberty"] 	= getInfoType('BUILDINGCLASS_STATUE_OF_LIBERTY')
		Dict["Broadway"] 			= getInfoType('BUILDINGCLASS_BROADWAY')
		Dict["Rock'n'Roll"] 		= getInfoType('BUILDINGCLASS_ROCKNROLL')
		Dict["Hollywood"] 			= getInfoType('BUILDINGCLASS_HOLLYWOOD')
		Dict["Great Dam"] 			= getInfoType('BUILDINGCLASS_GREAT_DAM')
		Dict["Pentagon"] 			= getInfoType('BUILDINGCLASS_PENTAGON')
		Dict["United Nations"] 		= getInfoType('BUILDINGCLASS_UNITED_NATIONS')
		Dict["Space Elevator"] 		= getInfoType('BUILDINGCLASS_SPACE_ELEVATOR')
		Dict["Military Academy"] 	= getInfoType('BUILDINGCLASS_MILITARY_ACADEMY')
		Dict["Artemis"] 			= getInfoType('BUILDINGCLASS_ARTEMIS')
		Dict["Sankore"] 			= getInfoType('BUILDINGCLASS_SANKORE')
		Dict["Great Wall"] 			= getInfoType('BUILDINGCLASS_GREAT_WALL')
		Dict["Statue of Zeus"] 		= getInfoType('BUILDINGCLASS_STATUE_OF_ZEUS')
		Dict["Mausoleum of Maussollos"] 	= getInfoType('BUILDINGCLASS_MAUSOLEUM_OF_MAUSSOLLOS')
		Dict["Cristo Redentor"] 			= getInfoType('BUILDINGCLASS_CRISTO_REDENTOR')
		Dict["Shwedagon Paya"] 				= getInfoType('BUILDINGCLASS_SHWEDAGON_PAYA')
		Dict["Moai Statues"] 				= getInfoType('BUILDINGCLASS_MOAI_STATUES')
		Dict["Corporation1"] 				= getInfoType('BUILDINGCLASS_CORPORATION_1')
		Dict["Corporation2"] 				= getInfoType('BUILDINGCLASS_CORPORATION_2')
		Dict["Corporation3"] 				= getInfoType('BUILDINGCLASS_CORPORATION_3')
		Dict["Corporation4"] 				= getInfoType('BUILDINGCLASS_CORPORATION_4')
		Dict["Corporation5"] 				= getInfoType('BUILDINGCLASS_CORPORATION_5')
		Dict["Corporation6"] 				= getInfoType('BUILDINGCLASS_CORPORATION_6')
		Dict["Corporation7"] 				= getInfoType('BUILDINGCLASS_CORPORATION_7')
		Dict["Apolistic Palace"] 			= getInfoType('BUILDINGCLASS_APOSTOLIC_PALACE')
		self.Buildings = Dict

	def getUnitCombatDict(self):
		return self.UnitCombats
		
	def initUnitCombatDict(self):
		gc = CyGlobalContext()
		getInfoType = gc.getInfoTypeForString
		Dict = {}
		Dict["Recon"] 		= getInfoType('UNITCOMBAT_RECON')
		Dict["Archer"] 		= getInfoType('UNITCOMBAT_ARCHER')
		Dict["Mounted"] 	= getInfoType('UNITCOMBAT_MOUNTED')
		Dict["Melee"] 		= getInfoType('UNITCOMBAT_MELEE')
		Dict["Siege"] 		= getInfoType('UNITCOMBAT_SIEGE')
		Dict["Gun"] 		= getInfoType('UNITCOMBAT_GUN')
		Dict["Armor"] 		= getInfoType('UNITCOMBAT_ARMOR')
		Dict["Helicopter"] 	= getInfoType('UNITCOMBAT_HELICOPTER')
		Dict["Naval"] 		= getInfoType('UNITCOMBAT_NAVAL')
		Dict["Air"] 		= getInfoType('UNITCOMBAT_AIR')
		self.UnitCombats = Dict

	def getImprovementDict(self):
		return self.Improvements
		
	def initImprovementDict(self):
		gc = CyGlobalContext()
		getInfoType = gc.getInfoTypeForString
		Dict = {}
		Dict["Farm"] 			= getInfoType('IMPROVEMENT_FARM')
		Dict["Fishing Boats"] 	= getInfoType('IMPROVEMENT_FISHING_BOATS')
		Dict["Whaling Boats"]	= getInfoType('IMPROVEMENT_WHALING_BOATS')
		Dict["Mine"] 			= getInfoType('IMPROVEMENT_MINE')
		Dict["Workshop"] 		= getInfoType('IMPROVEMENT_WORKSHOP')
		Dict["Lumbermill"]		= getInfoType('IMPROVEMENT_LUMBERMILL')
		Dict["Windmill"] 		= getInfoType('IMPROVEMENT_WINDMILL')
		Dict["Watermill"] 		= getInfoType('IMPROVEMENT_WATERMILL')
		Dict["Plantation"]		= getInfoType('IMPROVEMENT_PLANTATION')
		Dict["Quarry"] 			= getInfoType('IMPROVEMENT_QUARRY')
		Dict["Pasture"]			= getInfoType('IMPROVEMENT_PASTURE')
		Dict["Camp"] 			= getInfoType('IMPROVEMENT_CAMP')
		Dict["Well"] 			= getInfoType('IMPROVEMENT_WELL')
		Dict["Offshore Platform"] 	= getInfoType('IMPROVEMENT_OFFSHORE_PLATFORM')
		Dict["Winery"] 				= getInfoType('IMPROVEMENT_WINERY')
		Dict["Cottage"] 			= getInfoType('IMPROVEMENT_COTTAGE')
		Dict["Fort"] 				= getInfoType('IMPROVEMENT_FORT')
		Dict["Forest Preserve"] 	= getInfoType('IMPROVEMENT_FOREST_PRESERVE')
		self.Improvements = Dict

	def getGreatPeopleDict(self):
		return self.GreatPeople
		
	def initGreatPeopleDict(self):
		gc = CyGlobalContext()
		getInfoType = gc.getInfoTypeForString
		Dict = {}
		Dict["Prophet"] 	= getInfoType('UNITCLASS_PROPHET')
		Dict["Scientist"] 	= getInfoType('UNITCLASS_SCIENTIST')
		Dict["Merchant"] 	= getInfoType('UNITCLASS_MERCHANT')
		Dict["Engineer"] 	= getInfoType('UNITCLASS_ENGINEER')
		Dict["Artist"] 		= getInfoType('UNITCLASS_ARTIST')
		Dict["General"] 	= getInfoType('UNITCLASS_GREAT_GENERAL')
		Dict["Spy"] 		= getInfoType('UNITCLASS_GREAT_SPY')
		self.GreatPeople = Dict
			
	def isTemple(self, iB):
		Building = self.getBuildingDict()
		bValid = False
		if   iB == Building["Jewish Temple"]: 		bValid = True;
		elif iB == Building["Christian Temple"]:	bValid = True;
		elif iB == Building["Islamic Temple"]:		bValid = True;
		elif iB == Building["Hindu Temple"]:		bValid = True;
		elif iB == Building["Buddhist Temple"]:		bValid = True;
		elif iB == Building["Confucian Temple"]:	bValid = True;
		elif iB == Building["Taoist Temple"]:		bValid = True;
		return bValid
			
	def isMonastery(self, iB):
		Building = self.getBuildingDict()
		bValid = False
		if   iB == Building["Jewish Monastery"]: 	bValid = True;
		elif iB == Building["Christian Monastery"]:	bValid = True;
		elif iB == Building["Islamic Monastery"]:	bValid = True;
		elif iB == Building["Hindu Monastery"]:		bValid = True;
		elif iB == Building["Buddhist Monastery"]:	bValid = True;
		elif iB == Building["Confucian Monastery"]:	bValid = True;
		elif iB == Building["Taoist Monastery"]:	bValid = True;
		return bValid
			
	def isCathedral(self, iB):
		Building = self.getBuildingDict()
		bValid = False
		if   iB == Building["Jewish Cathedral"]: 	bValid = True;
		elif iB == Building["Christian Cathedral"]:	bValid = True;
		elif iB == Building["Islamic Cathedral"]:	bValid = True;
		elif iB == Building["Hindu Cathedral"]:		bValid = True;
		elif iB == Building["Buddhist Cathedral"]:	bValid = True;
		elif iB == Building["Confucian Cathedral"]:	bValid = True;
		elif iB == Building["Taoist Cathedral"]:	bValid = True;
		return bValid
			
	def isShrine(self, iB):
		Building = self.getBuildingDict()
		bValid = False
		if   iB == Building["Jewish Shrine"]: 		bValid = True;
		elif iB == Building["Christian Shrine"]:	bValid = True;
		elif iB == Building["Islamic Shrine"]:		bValid = True;
		elif iB == Building["Hindu Shrine"]:		bValid = True;
		elif iB == Building["Buddhist Shrine"]:		bValid = True;
		elif iB == Building["Confucian Shrine"]:	bValid = True;
		elif iB == Building["Taoist Shrine"]:		bValid = True;
		return bValid
			
	def getPercent(self, iOriginal, iPercent, iMin = 0, iMax = 100):
		iNewValue = 0
		if iOriginal != 0:
			iNewValue = iOriginal * iPercent
			iNewValue /= 100

		if iNewValue < iMin:
			return iMin
		if iNewValue > iMax:
			return iMax
		return iNewValue
		
	def showAutoPlayPopup(self):
		'Window for when user switches to AI Auto Play'
		popupSizeX = 400
		popupSizeY = 200
		screen = CyGInterfaceScreen("MainInterface", CvScreenEnums.MAIN_INTERFACE)
		xRes = screen.getXResolution()
		yRes = screen.getYResolution()
		popup = PyPopup.PyPopup(CvUtil.EventSetTurnsAutoPlayPopup, contextType = EventContextTypes.EVENTCONTEXT_ALL)
		popup.setPosition((xRes - popupSizeX) / 2, (yRes - popupSizeY) / 2 - 50)
		popup.setSize(popupSizeX, popupSizeY)
		popup.setHeaderString(CyTranslator().getText("TXT_KEY_AIAUTOPLAY_TURN_ON", ()))
		popup.setBodyString(CyTranslator().getText("TXT_KEY_AIAUTOPLAY_TURNS", ()))
		popup.addSeparator()
		popup.createPythonEditBox('10', 'Number of turns to turn over to AI', 0)
		popup.setEditBoxMaxCharCount(4, 2, 0)
		popup.addSeparator()
		popup.addButton("OK")
		popup.addButton(CyTranslator().getText("TXT_KEY_AIAUTOPLAY_CANCEL", ()))
		popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)
			
	def printd(self, szText):
		print(szText)
			
	def printScreen(self, szText):
		CyInterface().addImmediateMessage(szText,"")

	def addPopup(self, szText, sDDS):
		szTitle = szGameDate = CyGameTextMgr().getTimeStr(CyGame().getGameTurn(), false)
		popup = PyPopup.PyPopup(-1)
		popup.addDDS(sDDS, 0, 0, 128, 384)
		popup.addSeparator()
		popup.setHeaderString(szTitle)
		popup.setBodyString(szText)
		popup.launch(true, PopupStates.POPUPSTATE_IMMEDIATE)
	
	def getEffectInfo(self, name):
		gc = CyGlobalContext()
		for i in range(gc.getNumEffectInfos()):
			item=gc.getEffectInfo(i)
			if(item.getType()==name):
				return i

	def isAI(self, iPlayer):
		gc = CyGlobalContext()
		if not gc.getPlayer(iPlayer).isHuman():
			return True
		return False

	def isBarbarian(self, iPlayer):
		gc = CyGlobalContext()
		if iPlayer == gc.getBARBARIAN_PLAYER():
			return True
		return False

	def getNumPlayers(self):
	##########################################
	#' Counts the number of active players  '#
	##########################################
		gc = CyGlobalContext()
		iNum = 0
		for iPlayer in range(gc.getMAX_PLAYERS()):
			pPlayer = gc.getPlayer(iPlayer)
			if (pPlayer.isAlive() and iPlayer != gc.getBARBARIAN_PLAYER()):
				iNum+=1
		return iNum
























	
	
	